//+------------------------------------------------------------------+
//|MA rsi 3color  mtf                                     MA rsi.mq4 |
//|mtf forextsd.com   ki                 Copyright  2006, Eli hayun |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006, Eli hayun"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Orange
#property indicator_color2 Blue
#property indicator_color3 Red

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

//---- input parameters
extern int TimeFrame=0;

extern int       maPeriod  =80;
extern int       maMethod  = MODE_EMA;
extern int       maPrice   =  PRICE_CLOSE;
extern int       rsiPeriod =40;
extern int       rsiLevel  =50;
extern int       rsiLevelThreshold  =2;

extern int       Maxbars  =1500;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle (1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle (2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);

    SetIndexLabel(0,"MA ("+maPeriod+") RSI("+rsiPeriod+")["+TimeFrame+"]");
    SetIndexLabel(1,"MA ("+maPeriod+") RSI("+rsiPeriod+")["+TimeFrame+"]");
    SetIndexLabel(2,"MA ("+maPeriod+") RSI("+rsiPeriod+")["+TimeFrame+"]");


IndicatorShortName("MARSI  MA("+maPeriod+") RSI("+rsiPeriod+")["+TimeFrame+"]");
  if (TimeFrame<Period()) TimeFrame=Period();

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];

   int i,y=0,limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
     ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 

  
//    limit=Bars-counted_bars+TimeFrame/Period();
      limit = Bars-counted_bars;
      limit = MathMax (limit,TimeFrame/Period());
      limit = MathMin (limit,  	Maxbars);
//
//---- main loop
   for( i=0; i<limit; i++)
     {
   
   if (Time[i]<TimeArray[y]) y++;  
 
         double ma = iMA(NULL,TimeFrame,maPeriod, 0, maMethod, maPrice, y);
         double rsi= iRSI(NULL, TimeFrame, rsiPeriod, maPrice, y);
    //     ExtMapBuffer1[i]=EMPTY_VALUE;
   //       ExtMapBuffer2[i]=EMPTY_VALUE;
   //       ExtMapBuffer3[i]=EMPTY_VALUE;
        ExtMapBuffer1[i] = ma;
         if (rsi > rsiLevel+rsiLevelThreshold)
            ExtMapBuffer2[i] = ma;
  //        ExtMapBuffer2[i]=EMPTY_VALUE;
   //       ExtMapBuffer3[i]=EMPTY_VALUE;            
            
          if (rsi < rsiLevel-rsiLevelThreshold)
          ExtMapBuffer3[i] = ma;
  //         ExtMapBuffer1[i]=EMPTY_VALUE;
 //         ExtMapBuffer3[i]=EMPTY_VALUE;}
  //       else
           
  //            ExtMapBuffer1[i]=EMPTY_VALUE;
  //        ExtMapBuffer2[i]=EMPTY_VALUE;
   
   
     }
   return(0);
  }
//+------------------------------------------------------------------+